lexer grammar BML;
@members {
  public RecognitionException lastE = null;

  public void reportError(RecognitionException rex) {
    lastE = rex;
    MLog.putMsg(MLog.LEVEL_PPARSER, "LEXER ERROR");
    if ((MLog.getLogMask() & MLog.LEVEL_PPARSER) > 0) {
      System.err.println("LEXER ERROR");
      super.reportError(rex);
    }
  }
}
@header {
  package annot.textio;
  import annot.bcclass.*;
}

T128 : 'e' ;
T129 : 'E' ;
T130 : 'f' ;
T131 : 'F' ;
T132 : 'd' ;
T133 : 'D' ;
T134 : 'nullable' ;
T135 : 'non_null' ;

// $ANTLR src "annot/textio/BML.g3" 1009
PACKAGE: 'package';
// $ANTLR src "annot/textio/BML.g3" 1010
DEFAULTPACKAGE: '[default]';
// $ANTLR src "annot/textio/BML.g3" 1011
IMPORT: 'import';
// $ANTLR src "annot/textio/BML.g3" 1012
CLASS: 'class';
// $ANTLR src "annot/textio/BML.g3" 1013
INTERFACE: 'interface';
// $ANTLR src "annot/textio/BML.g3" 1014
PUBLIC: 'public';
// $ANTLR src "annot/textio/BML.g3" 1015
PROTECTED: 'protected';
// $ANTLR src "annot/textio/BML.g3" 1016
PRIVATE: 'private';
// $ANTLR src "annot/textio/BML.g3" 1017
ABSTRACT: 'abstract';
// $ANTLR src "annot/textio/BML.g3" 1018
STATIC: 'static';
// $ANTLR src "annot/textio/BML.g3" 1019
FINAL: 'final';
// $ANTLR src "annot/textio/BML.g3" 1020
NATIVE: 'native';
// $ANTLR src "annot/textio/BML.g3" 1021
SYNCHRONIZED: 'synchronized';
// $ANTLR src "annot/textio/BML.g3" 1022
TRANSIENT: 'transient';
// $ANTLR src "annot/textio/BML.g3" 1023
VOLATILE: 'volatile';
// $ANTLR src "annot/textio/BML.g3" 1024
STRICTFP: 'strictfp';
// $ANTLR src "annot/textio/BML.g3" 1025
VOID: 'void';
// $ANTLR src "annot/textio/BML.g3" 1026
BOOLEAN: 'boolean';
// $ANTLR src "annot/textio/BML.g3" 1027
BYTE: 'byte';
// $ANTLR src "annot/textio/BML.g3" 1028
CHAR: 'char';
// $ANTLR src "annot/textio/BML.g3" 1029
SHORT: 'short';
// $ANTLR src "annot/textio/BML.g3" 1030
INT: 'int';
// $ANTLR src "annot/textio/BML.g3" 1031
LONG: 'long';
// $ANTLR src "annot/textio/BML.g3" 1032
FLOAT: 'float';
// $ANTLR src "annot/textio/BML.g3" 1033
DOUBLE: 'double';
// $ANTLR src "annot/textio/BML.g3" 1034
EXTENDS: 'extends';
// $ANTLR src "annot/textio/BML.g3" 1035
IMPLEMENTS: 'implements';
// $ANTLR src "annot/textio/BML.g3" 1036
THROWS: 'throws';


// bml level
// IDisplayStyle must be modified as well

// $ANTLR src "annot/textio/BML.g3" 1042
EOF: '\f';
// $ANTLR src "annot/textio/BML.g3" 1043
EOL: '\n';
// $ANTLR src "annot/textio/BML.g3" 1044
CONSNAME: '<init>';
// $ANTLR src "annot/textio/BML.g3" 1045
STATICCONSNAME: '<clinit>';
// $ANTLR src "annot/textio/BML.g3" 1046
ASSERT: 'assert';
// $ANTLR src "annot/textio/BML.g3" 1047
LOOPSPEC: 'loop_specification';
// $ANTLR src "annot/textio/BML.g3" 1048
LINVARIANT: 'loop_inv';
// $ANTLR src "annot/textio/BML.g3" 1049
LDECREASES: 'decreases';
// $ANTLR src "annot/textio/BML.g3" 1050
INVARIANT: 'invariant';
// $ANTLR src "annot/textio/BML.g3" 1051
CONSTRAINT: 'constraint';
// $ANTLR src "annot/textio/BML.g3" 1052
REPRESENTS: 'represents';
// $ANTLR src "annot/textio/BML.g3" 1053
INITIALLY: 'initially';
// $ANTLR src "annot/textio/BML.g3" 1054
REQUIRES: 'requires';
// $ANTLR src "annot/textio/BML.g3" 1055
SC_START: '{|';
// $ANTLR src "annot/textio/BML.g3" 1056
SC_END: '|}';
// $ANTLR src "annot/textio/BML.g3" 1057
PRECONDITION: 'precondition';
// $ANTLR src "annot/textio/BML.g3" 1058
MODIFIES: 'modifies';
// $ANTLR src "annot/textio/BML.g3" 1059
ENSURES: 'ensures';
// $ANTLR src "annot/textio/BML.g3" 1060
CONSTANT_POOL: 'Constant pool:';
// $ANTLR src "annot/textio/BML.g3" 1061
SECOND_CONSTANT_POOL: 'Second constant pool:';
// $ANTLR src "annot/textio/BML.g3" 1062
CONST: 'const';
// $ANTLR src "annot/textio/BML.g3" 1063
COMMA: ',';
// $ANTLR src "annot/textio/BML.g3" 1064
EXSURES: 'exsures';
// $ANTLR src "annot/textio/BML.g3" 1065
COLON: ':';
// $ANTLR src "annot/textio/BML.g3" 1066
NOTHING: '\\nothing';
// $ANTLR src "annot/textio/BML.g3" 1067
EVERYTHING: '\\everything';
// $ANTLR src "annot/textio/BML.g3" 1068
LOG_AND: '&&';
// $ANTLR src "annot/textio/BML.g3" 1069
LOG_OR: '||';
// $ANTLR src "annot/textio/BML.g3" 1070
IMPLIES: '==>';
// $ANTLR src "annot/textio/BML.g3" 1071
EQUIV: '<==>';
// $ANTLR src "annot/textio/BML.g3" 1072
NOTEQUIV: '<=!=>';
// $ANTLR src "annot/textio/BML.g3" 1073
LOG_NOT: '~';
// $ANTLR src "annot/textio/BML.g3" 1074
SEMICOLON: ';';
// $ANTLR src "annot/textio/BML.g3" 1075
FORALL: '\\forall';
// $ANTLR src "annot/textio/BML.g3" 1076
EXISTS: '\\exists';
// $ANTLR src "annot/textio/BML.g3" 1077
TRUE: 'true';
// $ANTLR src "annot/textio/BML.g3" 1078
FALSE: 'false';
// $ANTLR src "annot/textio/BML.g3" 1079
LESS: '<';
// $ANTLR src "annot/textio/BML.g3" 1080
LESSEQ: '<=';
// $ANTLR src "annot/textio/BML.g3" 1081
EQ: '==';
// $ANTLR src "annot/textio/BML.g3" 1082
NOTEQ: '!=';
// $ANTLR src "annot/textio/BML.g3" 1083
GRTEQ: '>=';
// $ANTLR src "annot/textio/BML.g3" 1084
GRT: '>';
// $ANTLR src "annot/textio/BML.g3" 1085
EQUALS : '=';
// $ANTLR src "annot/textio/BML.g3" 1086
PAR_LEFT: '(';
// $ANTLR src "annot/textio/BML.g3" 1087
PAR_RIGHT: ')';
// $ANTLR src "annot/textio/BML.g3" 1088
BR_LEFT: '[';
// $ANTLR src "annot/textio/BML.g3" 1089
BR_RIGHT: ']';
// $ANTLR src "annot/textio/BML.g3" 1090
PLUS: '+';
// $ANTLR src "annot/textio/BML.g3" 1091
MINUS: '-';
// $ANTLR src "annot/textio/BML.g3" 1092
MULT: '*';
// $ANTLR src "annot/textio/BML.g3" 1093
DIV: '/';
// $ANTLR src "annot/textio/BML.g3" 1094
REM: '%';
// $ANTLR src "annot/textio/BML.g3" 1095
HASH: '#';
// $ANTLR src "annot/textio/BML.g3" 1096
SHL: '<<';
// $ANTLR src "annot/textio/BML.g3" 1097
SHR: '>>';
// $ANTLR src "annot/textio/BML.g3" 1098
USHR: '>>>';
// $ANTLR src "annot/textio/BML.g3" 1099
BITWISEAND: '&';
// $ANTLR src "annot/textio/BML.g3" 1100
BITWISEOR: '|';
// $ANTLR src "annot/textio/BML.g3" 1101
BITWISEXOR: '^';
// $ANTLR src "annot/textio/BML.g3" 1102
COND: '?';
// $ANTLR src "annot/textio/BML.g3" 1103
NULL: 'null'|'NULL';
// $ANTLR src "annot/textio/BML.g3" 1104
THIS: 'this'|'THIS';
// $ANTLR src "annot/textio/BML.g3" 1105
OLD_THIS: 'old_this'|'OLD_THIS';
// $ANTLR src "annot/textio/BML.g3" 1106
RESULT: '\\result';
// $ANTLR src "annot/textio/BML.g3" 1107
LV: 'lv';
// $ANTLR src "annot/textio/BML.g3" 1108
DOT2: '..';
// $ANTLR src "annot/textio/BML.g3" 1109
DOT: '.';
// $ANTLR src "annot/textio/BML.g3" 1110
OLD: '\\old';
// $ANTLR src "annot/textio/BML.g3" 1111
LENGTH: 'length';
// $ANTLR src "annot/textio/BML.g3" 1112
BML_ONE_LINE_START: '//@';
// $ANTLR src "annot/textio/BML.g3" 1113
ONE_LINE_COMMENT: '//';
// $ANTLR src "annot/textio/BML.g3" 1114
BML_START: '/*@';
// $ANTLR src "annot/textio/BML.g3" 1115
BML_END: '@*/';
// $ANTLR src "annot/textio/BML.g3" 1116
COMMENT_END: '*/';
// $ANTLR src "annot/textio/BML.g3" 1117
DOLARSIGN: '$';
// $ANTLR src "annot/textio/BML.g3" 1118
CLASS_CP: 'Class';
// $ANTLR src "annot/textio/BML.g3" 1119
FIELDREF_CP: 'Fieldref';
// $ANTLR src "annot/textio/BML.g3" 1120
METHODREF_CP: 'Methodref';
// $ANTLR src "annot/textio/BML.g3" 1121
INTERFACEMETHODREF_CP: 'InterfaceMethodref';
// $ANTLR src "annot/textio/BML.g3" 1122
STRING_CP: 'String';
// $ANTLR src "annot/textio/BML.g3" 1123
INTEGER_CP: 'Integer';
// $ANTLR src "annot/textio/BML.g3" 1124
UTF8_CP: 'Utf8';
// $ANTLR src "annot/textio/BML.g3" 1125
LONG_CP: 'Long';
// $ANTLR src "annot/textio/BML.g3" 1126
DOUBLE_CP: 'Double';
// $ANTLR src "annot/textio/BML.g3" 1127
NAMEANDTYPE_CP: 'NameAndType';
// $ANTLR src "annot/textio/BML.g3" 1128
FLOAT_CP: 'Float';

// $ANTLR src "annot/textio/BML.g3" 1130
fragment
HNUM: ('0'..'9') | ('a'..'f') | ('A'..'F');
// $ANTLR src "annot/textio/BML.g3" 1132
IDENT: ('a'..'z'|'A'..'Z'|'_')('a'..'z'|'A'..'Z'|'_'|'0'..'9')*;
// $ANTLR src "annot/textio/BML.g3" 1133
NAT: ('0'..'9')+;
// $ANTLR src "annot/textio/BML.g3" 1134
NATL: ('0'..'9')+'L';

// $ANTLR src "annot/textio/BML.g3" 1136
StringLiteral
    :  '"' ( EscapeSequence | ~('\\'|'"') )* '"'
    ;

// $ANTLR src "annot/textio/BML.g3" 1140
fragment
EscapeSequence
    :   '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\')
    |   UnicodeEscape
    |   OctalEscape
    ;

// $ANTLR src "annot/textio/BML.g3" 1147
fragment
OctalEscape
    :   '\\' ('0'..'3') ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7') ('0'..'7')
    |   '\\' ('0'..'7')
    ;

// $ANTLR src "annot/textio/BML.g3" 1154
fragment
UnicodeEscape
    :   '\\' 'u' HexDigit HexDigit HexDigit HexDigit
    ;

// $ANTLR src "annot/textio/BML.g3" 1159
fragment
HexDigit : ('0'..'9'|'a'..'f'|'A'..'F') ;

// $ANTLR src "annot/textio/BML.g3" 1162
WS: (' '|'\r'|'\t'|'\u000C'|'\n') {$channel=HIDDEN;} ;